## python-pcre2 0.4.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7.2)

project(pcre2)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_C_STANDARD 99)

set(PCRE2_INCLUDE_DIR ${CMAKE_BINARY_DIR}/src/libpcre2)
set(CYTHON_EXTRA_COMPILE_ARGS -DPCRE2_CODE_UNIT_WIDTH=8 -fPIC)

# Set PCRE2 options.
set(PCRE2_SUPPORT_JIT ON CACHE BOOL "" FORCE)
set(PCRE2_NEVER_BACKSLASH_C ON CACHE BOOL "" FORCE)

# Always make a release build.
set(CMAKE_BUILD_TYPE Release)

# Build PCRE2 library as both shared and static.
set(BUILD_STATIC_LIBS ON)
set(BUILD_SHARED_LIBS ON)
add_subdirectory(src/libpcre2)

# Build Cython code as shared.
set(BUILD_STATIC_LIBS OFF)
set(BUILD_SHARED_LIBS ON)
add_subdirectory(src/pcre2)

# Include PCRE2 header for Cython API.
install(FILES ${PCRE2_INCLUDE_DIR}/pcre2.h DESTINATION src/pcre2)

=== Makefile ===
SHELL = /bin/bash

init:
	git submodule update --init
	python3 -m venv ./.venv
	./.venv/bin/pip install -r ./requirements/build-requirements.txt
	./.venv/bin/pip install -r ./requirements/test-requirements.txt
	./.venv/bin/pip install .

build:
	./.venv/bin/pip install . --force-reinstall

clean:
	rm -rf ./dist
	rm -rf ./build
	rm -rf ./_skbuild
	find ./src/pcre2 -type f -name '*.c' -print0 | xargs -0 rm -vf
	find ./src/pcre2 -type f -name '*.html' -print0 | xargs -0 rm -vf
	find . -type f -name '*.pyc' | xargs rm -r
	find . -type d -name '*.egg-info' | xargs rm -r
	find . -type d -name '*.ipynb_checkpoints' | xargs rm -r

purge:
	rm -rf ./.venv

benchmark:
	./.venv/bin/python ./benchmarks/run_regex_redux.py

=== src/pcre2/CMakeLists.txt ===
find_package(Cython MODULE REQUIRED)
find_package(PythonExtensions MODULE REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# Build Cython with annotations.
set(CYTHON_ANNOTATE TRUE)

# Macro to add Cython files as modules, configured to build with PCRE2.
macro(add_pyx_file filename)
    add_cython_target(${filename} C PY3)
    add_library(${filename} MODULE ${filename})
    python_extension_module(${filename})

    target_link_libraries(${filename} pcre2-8-static)
    target_include_directories(${filename} PRIVATE ${PCRE2_INCLUDE_DIR})
    target_compile_options(${filename} PRIVATE ${CYTHON_EXTRA_COMPILE_ARGS})
    
    install(TARGETS ${filename} LIBRARY DESTINATION src/pcre2)
endmacro()

# GLOB pattern is recommended against,
# https://cmake.org/cmake/help/v3.14/command/file.html?highlight=file#filesystem
add_pyx_file(consts)
add_pyx_file(exceptions)
add_pyx_file(match)
add_pyx_file(methods)
add_pyx_file(pattern)
add_pyx_file(scanner)
add_pyx_file(utils)


# Include .pyx and .pxd files in distribution for use by Cython API.
install(
    FILES
        consts.pxd
        consts.pyx
        exceptions.pxd
        exceptions.pyx
        libpcre2.pxd
        match.pxd
        match.pyx
        methods.pxd
        methods.pyx
        pattern.pxd
        pattern.pyx
        scanner.pxd
        scanner.pyx
        utils.pxd
        utils.pyx
    DESTINATION
        src/pcre2
)

## python-pcre2 0.3.0+ds

=== debian/changelog ===
python-pcre2 (0.3.0+ds-1build2) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 17:57:29 +0000

python-pcre2 (0.3.0+ds-1build1) noble; urgency=medium

  * No-change rebuild to build with python3.12 as supported.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 02 Nov 2023 10:06:09 +0100

python-pcre2 (0.3.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Remove trailing whitespace in debian/copyright (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 14 Sep 2023 09:37:23 +0200

python-pcre2 (0.2.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1051798)

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 11 Sep 2023 15:01:03 +0200

=== debian/control ===
Source: python-pcre2
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               python3-all-dev,
               python3-setuptools,
               python3-skbuild,
               ninja-build,
               pybuild-plugin-pyproject,
               cython3,
               libpcre2-dev,
               python3-pytest <!nocheck>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/crusoe/python-pcre2
Vcs-Git: https://salsa.debian.org/crusoe/python-pcre2.git
Homepage: https://github.com/grtetrault/pcre2.py
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild

Package: python3-pcre2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Description: Python bindings for the PCRE2 regular expression library
 This package contains Python bindings for PCRE2. PCRE2 is the revised API for
 the Perl-compatible regular expressions (PCRE) library created by Philip Hazel.
 .
 For original source code, see the official PCRE2 repository:
 https://github.com/PCRE2Project/pcre2

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export PYBUILD_TEST_PYTEST=1

include /usr/share/dpkg/default.mk
# this provides:
# DEB_SOURCE: the source package name
# DEB_VERSION: the full version of the package (epoch + upstream vers. + revision)
# DEB_VERSION_EPOCH_UPSTREAM: the package's version without the Debian revision
# DEB_VERSION_UPSTREAM_REVISION: the package's version without the Debian epoch
# DEB_VERSION_UPSTREAM: the package's upstream version
# DEB_DISTRIBUTION: the distribution(s) listed in the current entry of debian/changelog
# SOURCE_DATE_EPOCH: the source release date as seconds since the epoch, as
#                    specified by <https://reproducible-builds.org/specs/source-date-epoch/>

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=pybuild

### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	do_stuff_for_testing
#endif

override_dh_auto_clean:
	dh_auto_clean || true

## python-pcre2 0.4.0+ds

=== debian/changelog ===
python-pcre2 (0.4.0+ds-1build2) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 10:26:26 +0000

python-pcre2 (0.4.0+ds-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 19:16:41 +0000

python-pcre2 (0.4.0+ds-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * Set upstream metadata fields: Bug-Submit.
  * Skip the JIT tests on armel. Closes: #1087722

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 19 Nov 2024 12:44:45 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                cython3,
                libpcre2-dev,
                python3-pytest <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/crusoe/python-pcre2
 Vcs-Git: https://salsa.debian.org/crusoe/python-pcre2.git
 Homepage: https://github.com/grtetrault/pcre2.py

## python-pcre2 0.6.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 set(CMAKE_C_STANDARD 99)
 
-set(PCRE2_INCLUDE_DIR ${CMAKE_BINARY_DIR}/src/libpcre2)
+set(PCRE2_INCLUDE_DIR ${CMAKE_BINARY_DIR}/src/libpcre2/interface)
 set(CYTHON_EXTRA_COMPILE_ARGS -DPCRE2_CODE_UNIT_WIDTH=8 -fPIC)
 
 # Set PCRE2 options.

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 SHELL = /bin/bash
 
 init:
-	git submodule update --init
+	git submodule update --init --recursive
 	python3 -m venv ./.venv
 	./.venv/bin/pip install -r ./requirements/build-requirements.txt
 	./.venv/bin/pip install -r ./requirements/test-requirements.txt

=== src/pcre2/CMakeLists.txt ===
find_package(Cython MODULE REQUIRED)
find_package(PythonExtensions MODULE REQUIRED)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# Build Cython with annotations.
set(CYTHON_ANNOTATE TRUE)

# Macro to add Cython files as modules, configured to build with PCRE2.
macro(add_pyx_file filename)
    add_cython_target(${filename} C PY3)
    add_library(${filename} MODULE ${filename})
    python_extension_module(${filename})

    target_link_libraries(${filename} pcre2-8-static)
    target_include_directories(${filename} PRIVATE ${PCRE2_INCLUDE_DIR})
    target_compile_options(${filename} PRIVATE ${CYTHON_EXTRA_COMPILE_ARGS})

    install(TARGETS ${filename} LIBRARY DESTINATION src/pcre2)
endmacro()

# GLOB pattern is recommended against,
# https://cmake.org/cmake/help/v3.14/command/file.html?highlight=file#filesystem
add_pyx_file(_cy)


# Include .pyx and .pxd files in distribution for use by Cython API.
install(
    FILES
        _libpcre2.pxd
        _cy.pyx
    DESTINATION
        src/pcre2
)

=== debian/changelog ===
python-pcre2 (0.6.0+ds-1) unstable; urgency=medium

  * Team upload
  * New upstream version 0.6.0 (Closes: #1119877)
  * Disable jit test on additional architectures (Closes: #1053528)

 -- Bastian Germann <bage@debian.org>  Mon, 09 Feb 2026 12:01:04 +0100

=== debian/control ===
--- 
+++ 
@@ -26,6 +26,3 @@
 Description: Python bindings for the PCRE2 regular expression library
  This package contains Python bindings for PCRE2. PCRE2 is the revised API for
  the Perl-compatible regular expressions (PCRE) library created by Philip Hazel.
- .
- For original source code, see the official PCRE2 repository:
- https://github.com/PCRE2Project/pcre2

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export LC_ALL=C.UTF-8

include /usr/share/dpkg/architecture.mk

export PYBUILD_TEST_ARGS= -k 'not test_re_compatibility'

ifneq (,$(filter alpha armel hppa m68k sh4 sparc64 x32, $(DEB_HOST_ARCH)))
export PYBUILD_TEST_ARGS+= -k 'not (test_pattern_jit)'
endif

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean || true
